Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::ParametricTNLP Class Reference

`#include <parametricTNLP.hpp>`

Inheritance diagram for Ipopt::ParametricTNLP:
[legend]

## Public Member Functions
| ParametricTNLP ()
| default constructor More...
virtual | ~ParametricTNLP ()
| default destructor More...
virtual bool | get_var_con_metadata (Index n, StringMetaDataMapType &var_string_md, IntegerMetaDataMapType &var_integer_md, NumericMetaDataMapType &var_numeric_md, Index m, StringMetaDataMapType &con_string_md, IntegerMetaDataMapType &con_integer_md, NumericMetaDataMapType &con_numeric_md)
| overload this method to return any meta data for the variables and the constraints More...
| ParametricTNLP ()
| default constructor More...
virtual | ~ParametricTNLP ()
| default destructor More...
virtual bool | get_var_con_metadata (Index n, StringMetaDataMapType &var_string_md, IntegerMetaDataMapType &var_integer_md, NumericMetaDataMapType &var_numeric_md, Index m, StringMetaDataMapType &con_string_md, IntegerMetaDataMapType &con_integer_md, NumericMetaDataMapType &con_numeric_md)
| overload this method to return any meta data for the variables and the constraints More...
Overloaded from TNLP
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp. More...
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem. More...
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm. More...
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value. More...
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective. More...
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals. More...
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL) More...
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL) More...
virtual bool | get_nlp_info (Index &n, Index &m, Index &nnz_jac_g, Index &nnz_h_lag, IndexStyleEnum &index_style)
| Method to return some info about the nlp. More...
virtual bool | get_bounds_info (Index n, Number *x_l, Number *x_u, Index m, Number *g_l, Number *g_u)
| Method to return the bounds for my problem. More...
virtual bool | get_starting_point (Index n, bool init_x, Number *x, bool init_z, Number *z_L, Number *z_U, Index m, bool init_lambda, Number *lambda)
| Method to return the starting point for the algorithm. More...
virtual bool | eval_f (Index n, const Number *x, bool new_x, Number &obj_value)
| Method to return the objective value. More...
virtual bool | eval_grad_f (Index n, const Number *x, bool new_x, Number *grad_f)
| Method to return the gradient of the objective. More...
virtual bool | eval_g (Index n, const Number *x, bool new_x, Index m, Number *g)
| Method to return the constraint residuals. More...
virtual bool | eval_jac_g (Index n, const Number *x, bool new_x, Index m, Index nele_jac, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL) More...
virtual bool | eval_h (Index n, const Number *x, bool new_x, Number obj_factor, Index m, const Number *lambda, bool new_lambda, Index nele_hess, Index *iRow, Index *jCol, Number *values)
| Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL) More...
Solution Methods
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution. More...
virtual void | finalize_metadata (Index n, const StringMetaDataMapType &var_string_md, const IntegerMetaDataMapType &var_integer_md, const NumericMetaDataMapType &var_numeric_md, Index m, const StringMetaDataMapType &con_string_md, const IntegerMetaDataMapType &con_integer_md, const NumericMetaDataMapType &con_numeric_md)
| This method is called just before finalize solution. More...
virtual void | finalize_solution (SolverReturn status, Index n, const Number *x, const Number *z_L, const Number *z_U, Index m, const Number *g, const Number *lambda, Number obj_value, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| This method is called when the algorithm is complete so the TNLP can store/write the solution. More...
virtual void | finalize_metadata (Index n, const StringMetaDataMapType &var_string_md, const IntegerMetaDataMapType &var_integer_md, const NumericMetaDataMapType &var_numeric_md, Index m, const StringMetaDataMapType &con_string_md, const IntegerMetaDataMapType &con_integer_md, const NumericMetaDataMapType &con_numeric_md)
| This method is called just before finalize solution. More...
Public Member Functions inherited from Ipopt::TNLP
| DECLARE_STD_EXCEPTION (INVALID_TNLP)
| TNLP ()
virtual | ~TNLP ()
| Default destructor. More...
virtual bool | intermediate_callback (AlgorithmMode mode, Index iter, Number obj_value, Number inf_pr, Number inf_du, Number mu, Number d_norm, Number regularization_size, Number alpha_du, Number alpha_pr, Index ls_trials, const IpoptData *ip_data, IpoptCalculatedQuantities *ip_cq)
| Intermediate Callback method for the user. More...
virtual Index | get_number_of_nonlinear_variables ()
virtual bool | get_list_of_nonlinear_variables (Index num_nonlin_vars, Index *pos_nonlin_vars)
virtual bool | get_scaling_parameters (Number &obj_scaling, bool &use_x_scaling, Index n, Number *x_scaling, bool &use_g_scaling, Index m, Number *g_scaling)
| overload this method to return scaling parameters. More...
virtual bool | get_variables_linearity (Index n, LinearityType *var_types)
| overload this method to return the variables linearity (TNLP::LINEAR or TNLP::NON_LINEAR). More...
virtual bool | get_constraints_linearity (Index m, LinearityType *const_types)
| overload this method to return the constraint linearity. More...
virtual bool | get_warm_start_iterate (IteratesVector &warm_start_iterate)
| overload this method to provide an Ipopt iterate (already in the form Ipopt requires it internally) for a warm start. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const

## Private Member Functions
Methods to block default compiler methods.
The compiler automatically generates the following three methods. Since the default compiler implementation is generally not what you want (for all but the most simple classes), we usually put the declarations of these methods in the private section and never implement them. This prevents the compiler from implementing an incorrect "default" behavior without us knowing. (See Scott Meyers book, "Effective C++")
| ParametricTNLP (const ParametricTNLP &)
ParametricTNLP & | operator= (const ParametricTNLP &)
| ParametricTNLP (const ParametricTNLP &)
ParametricTNLP & | operator= (const ParametricTNLP &)

## Private Attributes
Number | nominal_eta1_
Number | nominal_eta2_
Number | eta_1_perturbed_value_
Number | eta_2_perturbed_value_

## Additional Inherited Members
Public Types inherited from Ipopt::TNLP
enum | LinearityType { LINEAR, NON_LINEAR }
| Type of the constraints. More...
enum | IndexStyleEnum { C_STYLE =0, FORTRAN_STYLE =1 }
| overload this method to return the number of variables and constraints, and the number of non-zeros in the jacobian and the hessian. More...
typedef std::map< std::string, std::vector< std::string > > | StringMetaDataMapType
typedef std::map< std::string, std::vector< Index > > | IntegerMetaDataMapType
typedef std::map< std::string, std::vector< Number > > | NumericMetaDataMapType

## Detailed Description

Definition at line 15 of file parametricTNLP.hpp.

## Constructor & Destructor Documentation

Ipopt::ParametricTNLP::ParametricTNLP | ( |  | ) |

default constructor

virtual Ipopt::ParametricTNLP::~ParametricTNLP | ( |  | ) |
| virtual

default destructor

Ipopt::ParametricTNLP::ParametricTNLP | ( | const ParametricTNLP & |  | ) |
| private

Ipopt::ParametricTNLP::ParametricTNLP | ( |  | ) |

default constructor

virtual Ipopt::ParametricTNLP::~ParametricTNLP | ( |  | ) |
| virtual

default destructor

Ipopt::ParametricTNLP::ParametricTNLP | ( | const ParametricTNLP & |  | ) |
| private

## Member Function Documentation

virtual bool Ipopt::ParametricTNLP::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style
| ) |  |
| virtual

Method to return some info about the nlp.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u
| ) |  |
| virtual

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda
| ) |  |
| virtual

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value
| ) |  |
| virtual

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f
| ) |  |
| virtual

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g
| ) |  |
| virtual

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL)

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL)

Reimplemented from Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_var_con_metadata | ( | Index | n,
|  | StringMetaDataMapType & | var_string_md,
|  | IntegerMetaDataMapType & | var_integer_md,
|  | NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | StringMetaDataMapType & | con_string_md,
|  | IntegerMetaDataMapType & | con_integer_md,
|  | NumericMetaDataMapType & | con_numeric_md
| ) |  |
| virtual

overload this method to return any meta data for the variables and the constraints

Reimplemented from Ipopt::TNLP.

virtual void Ipopt::ParametricTNLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq
| ) |  |
| virtual

This method is called when the algorithm is complete so the TNLP can store/write the solution.

Implements Ipopt::TNLP.

virtual void Ipopt::ParametricTNLP::finalize_metadata | ( | Index | n,
|  | const StringMetaDataMapType & | var_string_md,
|  | const IntegerMetaDataMapType & | var_integer_md,
|  | const NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | const StringMetaDataMapType & | con_string_md,
|  | const IntegerMetaDataMapType & | con_integer_md,
|  | const NumericMetaDataMapType & | con_numeric_md
| ) |  |
| virtual

This method is called just before finalize solution.

It returns the parametric solution of the dual variables and bound multipliers.

Reimplemented from Ipopt::TNLP.

ParametricTNLP& Ipopt::ParametricTNLP::operator= | ( | const ParametricTNLP & |  | ) |
| private

virtual bool Ipopt::ParametricTNLP::get_nlp_info | ( | Index & | n,
|  | Index & | m,
|  | Index & | nnz_jac_g,
|  | Index & | nnz_h_lag,
|  | IndexStyleEnum & | index_style
| ) |  |
| virtual

Method to return some info about the nlp.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_bounds_info | ( | Index | n,
|  | Number * | x_l,
|  | Number * | x_u,
|  | Index | m,
|  | Number * | g_l,
|  | Number * | g_u
| ) |  |
| virtual

Method to return the bounds for my problem.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_starting_point | ( | Index | n,
|  | bool | init_x,
|  | Number * | x,
|  | bool | init_z,
|  | Number * | z_L,
|  | Number * | z_U,
|  | Index | m,
|  | bool | init_lambda,
|  | Number * | lambda
| ) |  |
| virtual

Method to return the starting point for the algorithm.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number & | obj_value
| ) |  |
| virtual

Method to return the objective value.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_grad_f | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number * | grad_f
| ) |  |
| virtual

Method to return the gradient of the objective.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Number * | g
| ) |  |
| virtual

Method to return the constraint residuals.

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_jac_g | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Index | m,
|  | Index | nele_jac,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the jacobian (if "values" is NULL) 2) The values of the jacobian (if "values" is not NULL)

Implements Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::eval_h | ( | Index | n,
|  | const Number * | x,
|  | bool | new_x,
|  | Number | obj_factor,
|  | Index | m,
|  | const Number * | lambda,
|  | bool | new_lambda,
|  | Index | nele_hess,
|  | Index * | iRow,
|  | Index * | jCol,
|  | Number * | values
| ) |  |
| virtual

Method to return: 1) The structure of the hessian of the lagrangian (if "values" is NULL) 2) The values of the hessian of the lagrangian (if "values" is not NULL)

Reimplemented from Ipopt::TNLP.

virtual bool Ipopt::ParametricTNLP::get_var_con_metadata | ( | Index | n,
|  | StringMetaDataMapType & | var_string_md,
|  | IntegerMetaDataMapType & | var_integer_md,
|  | NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | StringMetaDataMapType & | con_string_md,
|  | IntegerMetaDataMapType & | con_integer_md,
|  | NumericMetaDataMapType & | con_numeric_md
| ) |  |
| virtual

overload this method to return any meta data for the variables and the constraints

Reimplemented from Ipopt::TNLP.

virtual void Ipopt::ParametricTNLP::finalize_solution | ( | SolverReturn | status,
|  | Index | n,
|  | const Number * | x,
|  | const Number * | z_L,
|  | const Number * | z_U,
|  | Index | m,
|  | const Number * | g,
|  | const Number * | lambda,
|  | Number | obj_value,
|  | const IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cq
| ) |  |
| virtual

This method is called when the algorithm is complete so the TNLP can store/write the solution.

Implements Ipopt::TNLP.

virtual void Ipopt::ParametricTNLP::finalize_metadata | ( | Index | n,
|  | const StringMetaDataMapType & | var_string_md,
|  | const IntegerMetaDataMapType & | var_integer_md,
|  | const NumericMetaDataMapType & | var_numeric_md,
|  | Index | m,
|  | const StringMetaDataMapType & | con_string_md,
|  | const IntegerMetaDataMapType & | con_integer_md,
|  | const NumericMetaDataMapType & | con_numeric_md
| ) |  |
| virtual

This method is called just before finalize solution.

It returns the parametric solution of the dual variables and bound multipliers.

Reimplemented from Ipopt::TNLP.

ParametricTNLP& Ipopt::ParametricTNLP::operator= | ( | const ParametricTNLP & |  | ) |
| private

## Member Data Documentation

Number Ipopt::ParametricTNLP::nominal_eta1_
| private

Definition at line 118 of file parametricTNLP.hpp.

Number Ipopt::ParametricTNLP::nominal_eta2_
| private

Definition at line 119 of file parametricTNLP.hpp.

Number Ipopt::ParametricTNLP::eta_1_perturbed_value_
| private

Definition at line 121 of file parametricTNLP.hpp.

Number Ipopt::ParametricTNLP::eta_2_perturbed_value_
| private

Definition at line 122 of file parametricTNLP.hpp.

The documentation for this class was generated from the following files:

- contrib/sIPOPT/examples/parametric_cpp/parametricTNLP.hpp
- contrib/sIPOPT/examples/parametric_dsdp_cpp/parametricTNLP.hpp